// 
// 
// 

#include "DirectGpio.h"

DirectInput::DirectInput(GpioNr gpioNr) : MinionInput(gpioNr, DirectInputType) {
	pinMode(gpioNr, INPUT);
	_value = digitalRead(gpioNr);
}

int DirectInput::Read() {
	_value = digitalRead(_gpioNr);
	return _value;
}

DirectGpio::DirectGpio(GpioNr gpioNr, uint8_t mode) : MinionGpio(gpioNr, DirectGpioType, mode) {
	pinMode(gpioNr, mode);
	_value = digitalRead(gpioNr);
}

DirectGpio::DirectGpio(GpioNr gpioNr, uint8_t mode, uint8_t initialValue) : MinionGpio(gpioNr, DirectGpioType, mode) {
	pinMode(gpioNr, mode);
	_value = initialValue;
	digitalWrite(_gpioNr, _value);
}

int DirectGpio::Read() {
	_value = digitalRead(_gpioNr);
	return _value;
}

bool DirectGpio::Write(uint8_t value) {
	digitalWrite(_gpioNr, value);
	_value = value;
	return true;
}

bool DirectGpio::Toggle() {
	if (_value == HIGH) {
		return this->Write(LOW);
	}
	else {
		return this->Write(HIGH);
	}
}

bool DirectGpio::SetMode(uint8_t mode) {
	pinMode(_gpioNr, mode);
	return true;
}


