/*
 Name:		MinionGpio.h
 Created:	07.03.2019 15:50:14
 Author:	jkeller
 Editor:	http://www.visualmicro.com
*/

#ifndef _MinionGpio_h
#define _MinionGpio_h

#pragma once
#include <Arduino.h>

constexpr int nrOfGpios = 100;

enum PinType
{
	DirectGpioType = 0,
	DirectInputType = 1,
	TCA9534GpioType = 2
};

enum GpioNr
{
	GPIO2 = 2,
	GPIO9 = 9,
	GPIO10 = 10,
	GPIO32 = 32,
	GPIO33 = 33,
	INPUT_ONLY_GPIO34 = 34,
	INPUT_ONLY_GPIO35 = 35,
	INPUT_ONLY_GPIO36 = 36,
	INPUT_ONLY_GPIO37 = 37,
	INPUT_ONLY_GPIO38 = 38,
	INPUT_ONLY_GPIO39 = 39
};


class MinionInput {
public:
	MinionInput() {};
	MinionInput(int gpioNr, PinType type);

	virtual int Read() = 0;

	int GetGpioNr();
	PinType GetType();

protected:
	int _gpioNr;
	PinType _type;
	uint8_t _value;
};

class MinionGpio : public MinionInput {
public:
	MinionGpio();
	MinionGpio(int gpioNr, PinType type, uint8_t mode);

	uint8_t GetMode();

	virtual int Read() = 0;
	virtual bool Write(uint8_t value) = 0;
	virtual bool Toggle() = 0;
	virtual bool SetMode(uint8_t mode) = 0;

protected:
	uint8_t _mode;
};

#endif

