/*
 Name:		TCA9534.h
 Created:	07.03.2019 15:50:14
 Author:	jkeller
 Editor:	http://www.visualmicro.com
*/

#ifndef _TCA9534_h
#define _TCA9534_h

#pragma once
#include "MinionGpio.h"
#include "MinionI2cBus.h"
#include "MinionI2cBaseDevice.h"

enum Tca9534Register {
	InputPortRegister = 0,
	OutputPortRegister = 1,
	PolarityInversionRegister = 2,
	ConfigurationRegister = 3
};

enum GpioExpanderPort
{
	P0 = 0,
	P1 = 1,
	P2 = 2,
	P3 = 3,
	P4 = 4,
	P5 = 5,
	P6 = 6,
	P7 = 7
};

class TCA9534 : public MinionI2cBaseDevice {

private:
	bool _setupRun = false;
	uint8_t _inputPort;
	uint8_t _outputPort;
	uint8_t _polarityInversion;
	uint8_t _configuration;

	bool _writeOutputPortRegister();
	bool _writeConfigurationRegister();

public:
	TCA9534(MinionI2cBus& i2cBus, DeviceInfoStruct& deviceInfo);

	void Setup();
	bool ReadInputChannel(int channelNr);
	bool ChangeOutputChannelValue(int channelNr, bool value);
	bool ChangeChannelConfiguration(int channelNr, uint8_t mode);
	void ChangeChannelInputInverstion(int channelNr, bool inverted);

	bool WriteRegister(Tca9534Register tca9534Register, uint8_t registerContent);
	uint8_t ReadRegister(Tca9534Register tca9534Register);
};


#endif
