/*
 Name:		TCA9534Gpio.h
 Created:	07.03.2019 15:50:14
 Author:	jkeller
 Editor:	http://www.visualmicro.com
*/

#ifndef _TCA9534Gpio_h
#define _TCA9534Gpio_h

#pragma once
#include "MinionGpio.h"
#include "TCA9534.h"

class TCA9534Gpio : public MinionGpio {
public:
	TCA9534Gpio(TCA9534& tca9534, GpioExpanderPort portNr, uint8_t mode);
	TCA9534Gpio(TCA9534& tca9534, GpioExpanderPort portNr, uint8_t mode, uint8_t initialValue);
	int Read();
	bool Write(uint8_t value);
	bool Toggle();
	bool SetMode(uint8_t mode);

private:
	bool _inputInverted;
	bool _valueInitialized = false;
	TCA9534& _tca9534;
};

#endif
