/*
 Name:		MinionI2cBaseDevice.cpp
 Created:	25.04.2019 17:23:12
 Author:	aoetiker
 Editor:	http://www.visualmicro.com
*/

#include "MinionI2cBaseDevice.h"

MinionI2cBaseDevice::MinionI2cBaseDevice(MinionI2cBus& i2cBus, DeviceInfoStruct deviceInfo)
    : _i2cBus(i2cBus), _deviceInfo(deviceInfo)
{
}

bool MinionI2cBaseDevice::Transmit(uint8_t mode, uint8_t* buffer, uint8_t readSize, uint8_t writeSize)
{
	//Serial.println("*** MinionI2cDevice::Transmit ***");
    return _i2cBus.GenericMessage(&_deviceInfo, mode, buffer, readSize, writeSize);
}

bool MinionI2cBaseDevice::Connected()
{
    //Serial.println("*** MinionI2cDevice::Connected ***");
    return _i2cBus.CheckDeviceConnection(&_deviceInfo);
}






