/*
 Name:		MinionI2cBaseDevice.h
 Created:	25.04.2019 17:21:44
 Author:	aoetiker
 Editor:	http://www.visualmicro.com
*/

#ifndef _MinionI2cBaseDevice_h
#define _MinionI2cBaseDevice_h


#if defined(ARDUINO) && ARDUINO >= 100
    #include "arduino.h"
#else
    #include "WProgram.h"
#endif

#include "MinionI2cBus.h"



class MinionI2cBaseDevice
{
public:
    MinionI2cBaseDevice(MinionI2cBus& i2cBus, DeviceInfoStruct deviceInfo);
    DeviceInfoStruct _deviceInfo;
    //-----------------------------------------------------------------------------------------------------------
    // The Device Path Describes the Location of the Device in the Multiplexer I2c Bus
    //
    // Number Of Multiplexer: Size of the MultiplexerConfiguration Array
    // MulitplexerConfiguration*: Index and Channel of Each Multiplexer in the Path
    //
    // The first Array Entry describes the first Multiplexer Index (Index of the busDefinition Array) and Channel.
    //
    // Example of a Device on the 3rd Mux Channel 1:
    //
    //   1. Mux    2. Mux    3. Mux
    //  {0 , 2} , {3 , 4} , {2 , 1} 

    bool Transmit(uint8_t mode, uint8_t* buffer, uint8_t readSize, uint8_t writeSize);
    bool Connected();

private:
    
    MinionI2cBus& _i2cBus;
};



#endif

